dofile("sys/lua/wrapper.lua")

-- edit settings here

	NUKE_DMG      = 1500 -- (Damage)
	NUKE_RANGE    = 3200 -- (Range. 3200 equals 100 tiles)
	NUKE_POWER    = 150  -- (How long it shakes. 50 equals 1 second)
	NUKE_INTERVAL = 15   -- How many seconds until one can plant the next nuke

-- settings end





beepimg = nil

nukeset = false
nukeimg = nil
timer = 0
x = 0
y = 0

interval = 15

addhook("serveraction", "on_sv")
function on_sv(id, button)
	if nukeset == false and button == 1 and interval >= NUKE_INTERVAL then
		nukeset = true
		nukeimg = image("gfx/V/nuke.png", player(id, "x"), player(id, "y"), 0)
		
		beepimg = image("gfx/V/flare1.bmp", player(id, "x"), player(id, "y"), 1)
		imagealpha(beepimg, 0.0)
		imageblend(beepimg, 1)
		imagecolor(beepimg, 255, 0, 0)
		
		timer = 12 -- 12 for 10 ticks, then a flash, then after 1 second the explosion
		x = player(id, "x")
		y = player(id, "y")
	else
		msg2(id, "Nuke can only be used every 15 seconds.")
	end
end

addhook("second", "on_second")
function on_second()

	interval = interval + 1
	
	if nukeset then
		timer = timer - 1
		imagealpha(beepimg, 1.0)
		tween_alpha(beepimg, 1000, 0.0)
		
		if timer > 1 then
			sv_sound("V/nuke_modern.wav")
		elseif timer == 1 then
			lp = player(0, "tableliving")
			for i,v in pairs(lp) do
				frange = math.ceil( math.sqrt( math.pow( tonumber(player(v, "x")) - x,2) + math.pow( tonumber(player(v, "y") - y),2) ) / NUKE_RANGE * 99 )
				if frange > 99 then -- range > NUKE_RANGE? note: 3200 (default) equals range of 100x100 map from one end to the other (not diagonally)
					frange = 99
				end

				flashplayer(v, tostring(100 - frange))
				shake(v, NUKE_POWER)
			end
		else
			explosion(x, y, NUKE_RANGE, NUKE_DMG, 0)
			nukeset = false
			freeimage(nukeimg)
			freeimage(beepimg)
			
			interval = 0
		end
	end
end
